#ifndef _Container_H__
#define _Container_H__

#include <vector>
#include <queue>

using namespace std;

class ViewCell;
class HierarchyNode;
class SceneGraphNode;
class Intersectable;
class Polygon3;
class Ray;

/** Container storing polygons used during BSP tree construction.
*/
typedef vector<Polygon3 *> PolygonContainer;

/** Container storing a bundle of rays.
*/
typedef vector<Ray *> RayContainer;

/** Container for Mesh pointers primarily for the use within the kDTree and
    BSP hierarchies */
typedef vector<Intersectable *> ObjectContainer;

/** Container for ViewCell pointers primarily for the use within the kDTree and
    BSP hierarchies */

typedef vector<ViewCell *> ViewCellContainer;

/** Container for ViewCell pointers primarily for the use within the kDTree and
    BSP hierarchies */
//typedef vector<MeshInstance *> MeshInstanceContainer;

/** Container for HierarchyNodes pointers primarily for the use within the kDTree and
    BSP hierarchies */

typedef vector<HierarchyNode *> NodeContainer;


typedef vector<SceneGraphNode *> SceneGraphNodeContainer;



#endif // _Container_H__

