#ifndef _SceneGraph_H__
#define _SceneGraph_H__

#include <string>
using namespace std;

#include "Containers.h"
#include "AxisAlignedBox3.h"

  
/** Basic scene graph node, we are interested only in bounding boxes and topology
    of the scene graph */
class SceneGraphNode {
public:
  ObjectContainer mGeometry;
  SceneGraphNodeContainer mChildren;
  AxisAlignedBox3 mBox;
};


/** Scene graph class */
class SceneGraph {

public:
  SceneGraphNode *mRoot;
  bool Export(const string filename);
  
  int CollectObjects(ObjectContainer *instances);

  int
	AssignObjectIds();

protected:
};




#endif
