#ifndef _VssPreprocessor_H__
#define _VssPreprocessor_H__

#include <fstream>
using namespace std;

#include "Preprocessor.h"


/** Sampling based visibility preprocessing. The implementation is based on heuristical
    sampling of view space */
class VssPreprocessor : public Preprocessor {
public:
	int mPass;

  int mSamplesPerPass;
  int mTotalSamples;
  int mKdPvsDepth;
  ofstream mStats;
  ObjectContainer mObjects;
  RayContainer mSampleRays;
	
  VssPreprocessor();

  ~VssPreprocessor();

  virtual bool ComputeVisibility();

  void
  SetupRay(Ray &ray, 
		   const Vector3 &point, 
		   const Vector3 &direction,
		   const int type);

  KdNode *
  GetNodeForPvs(KdLeaf *leaf);

	int
	AddNodeSamples(const Ray &ray,
								 Intersectable *sObject,
								 Intersectable *tObject
								 );

	int
	CastRay(Intersectable *object,
					Ray &ray);
	
	KdNode *
	GetNodeToSample(Intersectable *object);

};



#endif
